# Class DefaultGridSpatialRepresentation

Object
AbstractMetadata
ModifiableMetadata
ISOMetadata
AbstractSpatialRepresentation
DefaultGridSpatialRepresentation

All Implemented Interfaces:
  `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `GridSpatialRepresentation`, `SpatialRepresentation`

Direct Known Subclasses:
  `DefaultGeorectified`, `DefaultGeoreferenceable`

public class DefaultGridSpatialRepresentation extends AbstractSpatialRepresentation implements GridSpatialRepresentation
Method used to represent geographic information in the dataset. The following properties are mandatory in a well-formed metadata according ISO 19115:
`MD_GridSpatialRepresentation` `├─numberOfDimensions…………………………………………………` Number of independent spatial-temporal axes. `├─axisDimensionProperties……………………………………` Information about spatial-temporal axis properties. `│ ├─dimensionName……………………………………………………` Name of the axis. `│ └─dimensionSize……………………………………………………` Number of elements along the axis. `├─cellGeometry…………………………………………………………………` Identification of grid data as point or cell. `└─transformationParameterAvailability……` Indication of whether or not parameters for transformation exists.

## Limitations

- Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
- Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.

Since:
  0.3
See Also:
  - Serialized Form

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class ModifiableMetadata

  `ModifiableMetadata​.State`

- ## Field Summary

  ### Fields inherited from class ISOMetadata

  `identifiers`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultGridSpatialRepresentation()`
  Constructs an initially empty grid spatial representation.
  `DefaultGridSpatialRepresentation(GridSpatialRepresentation object)`
  Constructs a new instance initialized with the values from the specified metadata object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultGridSpatialRepresentation`
  `castOrCopy(GridSpatialRepresentation object)`
  Returns a SIS metadata implementation with the values of the given arbitrary implementation.
  `List<Dimension>`
  `getAxisDimensionProperties()`
  Returns information about spatial-temporal axis properties.
  `CellGeometry`
  `getCellGeometry()`
  Returns the identification of grid data as point or cell.
  `Integer`
  `getNumberOfDimensions()`
  Returns the number of independent spatial-temporal axes.
  `boolean`
  `isTransformationParameterAvailable()`
  Returns indication of whether or not parameters for transformation exists.
  `void`
  `setAxisDimensionProperties(List<? extends Dimension> newValues)`
  Sets the information about spatial-temporal axis properties.
  `void`
  `setCellGeometry(CellGeometry newValue)`
  Sets identification of grid data as point or cell.
  `void`
  `setNumberOfDimensions(Integer newValue)`
  Sets the number of independent spatial-temporal axes.
  `void`
  `setTransformationParameterAvailable(boolean newValue)`
  Sets indication of whether or not parameters for transformation exists.

  ### Methods inherited from class AbstractSpatialRepresentation

  `castOrCopy, getScope, setScope`

  ### Methods inherited from class ISOMetadata

  `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier`

  ### Methods inherited from class ModifiableMetadata

  `checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, deepCopy, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, writeCollection, writeList, writeMap, writeSet`

  ### Methods inherited from class AbstractMetadata

  `asMap, asTreeTable, clone, equals, equals, getInterface, hashCode, isEmpty, nilReasons, prune, toString`

  ### Methods inherited from class Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### DefaultGridSpatialRepresentation

    public DefaultGridSpatialRepresentation()
    Constructs an initially empty grid spatial representation.

  - ### DefaultGridSpatialRepresentation

    public DefaultGridSpatialRepresentation(GridSpatialRepresentation object)
    Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, because the other metadata contained in the given object are not recursively copied.

    #### Note on properties validation

    This constructor does not verify the property values of the given metadata (e.g. whether it contains unexpected negative values). This is because invalid metadata exist in practice, and verifying their validity in this copy constructor is often too late. Note that this is not the only hole, as invalid metadata instances can also be obtained by unmarshalling an invalid XML document.
    Parameters:
      `object` - the metadata to copy values from, or `null` if none.
    See Also:
      - `castOrCopy(GridSpatialRepresentation)`

- ## Method Details

  - ### castOrCopy

    public static DefaultGridSpatialRepresentation castOrCopy(GridSpatialRepresentation object)
    Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
    - If the given object is `null`, then this method returns `null`.
    - Otherwise if the given object is an instance of `Georectified` or `Georeferenceable`, then this method delegates to the `castOrCopy(…)` method of the corresponding SIS subclass. Note that if the given object implements more than one of the above-cited interfaces, then the `castOrCopy(…)` method to be used is unspecified.
    - Otherwise if the given object is already an instance of `DefaultGridSpatialRepresentation`, then it is returned unchanged.
    - Otherwise a new `DefaultGridSpatialRepresentation` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, because the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getNumberOfDimensions

    @ValueRange(minimum=0.0) public Integer getNumberOfDimensions()
    Returns the number of independent spatial-temporal axes.
    Specified by:
      `getNumberOfDimensions` in interface `GridSpatialRepresentation`
    Returns:
      number of independent spatial-temporal axes, or `null`.

  - ### setNumberOfDimensions

    public void setNumberOfDimensions(Integer newValue)
    Sets the number of independent spatial-temporal axes.
    Parameters:
      `newValue` - the new number of dimension, or `null`.
    Throws:
      `IllegalArgumentException` - if the given value is negative.

  - ### getAxisDimensionProperties

    public List<Dimension> getAxisDimensionProperties()
    Returns information about spatial-temporal axis properties.
    Specified by:
      `getAxisDimensionProperties` in interface `GridSpatialRepresentation`
    Returns:
      information about spatial-temporal axis properties.

  - ### setAxisDimensionProperties

    public void setAxisDimensionProperties(List<? extends Dimension> newValues)
    Sets the information about spatial-temporal axis properties.
    Parameters:
      `newValues` - the new axis dimension properties.

  - ### getCellGeometry

    public CellGeometry getCellGeometry()
    Returns the identification of grid data as point or cell.
    Specified by:
      `getCellGeometry` in interface `GridSpatialRepresentation`
    Returns:
      identification of grid data as point or cell, or `null`.

  - ### setCellGeometry

    public void setCellGeometry(CellGeometry newValue)
    Sets identification of grid data as point or cell.
    Parameters:
      `newValue` - the new cell geometry.

  - ### isTransformationParameterAvailable

    public boolean isTransformationParameterAvailable()
    Returns indication of whether or not parameters for transformation exists.
    Specified by:
      `isTransformationParameterAvailable` in interface `GridSpatialRepresentation`
    Returns:
      whether or not parameters for transformation exists.

  - ### setTransformationParameterAvailable

    public void setTransformationParameterAvailable(boolean newValue)
    Sets indication of whether or not parameters for transformation exists.
    Parameters:
      `newValue` - `true` if the transformation parameters are available.